---
schema_version: "1"
id: 629b0a821c64b7d96de92a73d4af0f0cff788be55dfc6b4f363a6e869c42f644
title: Data Catalogs (deprecated)
collection: developer
version: current
locale: en-us
portal_url: https://docs.salesforce.com/developer/current/en-us/commerce-cloud/b2c-commerce/references/generated-api-specs/ocapi-data-catalogs.md
canonical_url: https://developer.salesforce.com/docs/commerce/b2c-commerce/references/ocapi-data-catalogs
source_site: developer.salesforce.com
content_type: documentation
content_hash: d365462d0753f1136d5621abbc01b83ee15ab2282aa64fa5708aada9903afcc9
products:
  - B2C Commerce
  - Salesforce APIs
---
Data Catalogs (deprecated)

# Data Catalogs (deprecated)

Data API endpoints enable developers to build applications for merchants: Create, update, delete business objects, like products, customers, pricing and promotions or assignments. They typically provide read and write access and are designed for moderate usage.

**Version:** 25.6

## Servers

*   `https://{host}/s/-/dw/data/v25_6`

Protocols: https.

## Security

*   `oauth2_application` (oauth2) Authentication flow with client ID and password with account manager.
    *   OAuth flow application (tokenUrl: https://account.demandware.com:443/dwsso/oauth2/access\_token)
    *   Scope x-info: Scopes are NOT supported. This is just a dummy, because the 'scopes' field is required.
*   `client_id` (apiKey) Add client ID for application identification. Alternative as 'client\_id' query parameter.
    *   API key in header: x-dw-client-id

## Operations

### GET Get Catalogs

`GET /catalogs`

Operation ID: `Get Catalogs`. Tags: catalogs. Security: oauth2\_application.

Action to get all the catalogs with no filtering.

#### Parameters

*   `start` (query, integer (int32)) Optional start index for retrieving the items from a given index (default 0).
*   `count` (query, integer (int32)) Optional count for retrieving only a subset of the items (default is 25).
*   `select` (query, string) The property selector.
*   `expand` (query, array of string)

#### Responses

*   **default**
    
    Media type: `application/json, text/xml`. Schema: `catalogs`.
    

### GET Get Catalog

`GET /catalogs/{catalog_id}`

Operation ID: `Get Catalog`. Tags: catalogs. Security: oauth2\_application.

Gets catalog information by catalog Id.

Expansion "stats" can be used to retrieved some expensive statistic data, such as assigned\_product\_count and owned\_product\_count. Example: /s/-/dw/data/v99\_9/catalogs/my-catalog?expand=stats

This endpoint may return the following faults:

*   404 - CatalogNotFoundException - Thrown in case the catalog does not exist matching the given id or the catalog identified was already in deletion.

#### Parameters

*   `catalog_id` (path, string, required) The id of the requested catalog.  
    Minimum length: 1.
*   `expand` (query, array of string)
*   `select` (query, string) the selector for the get. If not passed, the defaultSelector will be used instead.

#### Responses

*   **404** `CatalogNotFoundException` - Thrown in case the catalog does not exist matching the given id or the catalog identified was already in deletion.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `catalog`.
    

### PATCH Update Catalog

`PATCH /catalogs/{catalog_id}`

Operation ID: `Update Catalog`. Tags: catalogs. Security: oauth2\_application.

Updates the catalog with the specified information.

This endpoint may return the following faults:

*   404 - CatalogNotFoundException - Thrown in case the catalog id is unknown.

#### Parameters

*   `catalog_id` (path, string, required) The id of the requested catalog.  
    Minimum length: 1.

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `catalog`.

#### Responses

*   **404** `CatalogNotFoundException` - Thrown in case the catalog id is unknown.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `catalog`.
    

### GET Get Categories

`GET /catalogs/{catalog_id}/categories`

Operation ID: `Get Categories`. Tags: catalogs. Security: oauth2\_application.

Action to get all the categories with no filtering.

This endpoint may return the following faults:

*   404 - CatalogNotFoundException - Indicates that the catalog is not provided in the request.

#### Parameters

*   `catalog_id` (path, string, required)  
    Minimum length: 1.
*   `start` (query, integer (int32)) Optional start index for retrieving the items from a given index (default 0).
*   `count` (query, integer (int32)) Optional count for retrieving only a subset of the items (default is 25).
*   `select` (query, string) The property selector.
*   `expand` (query, array of string)

#### Responses

*   **404** `CatalogNotFoundException` - Indicates that the catalog is not provided in the request.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `categories`.
    

### GET Get category

`GET /catalogs/{catalog_id}/categories/{category_id}`

Operation ID: `Get category`. Tags: catalogs. Security: oauth2\_application.

Action to read an existing category within a catalog. By default, the server also returns the first level of sub-categories, but you can specify another level by setting the levels parameter. Please note, using a large value for levels may cause performance issues in case of a large and deep category tree.

This endpoint may return the following faults:

*   404 - CatalogNotFoundException - Indicates that the catalog is not provided in the request.
*   404 - CategoryNotFoundException - Indicates that the category does not exist for the catalog provided in the request.

#### Parameters

*   `catalog_id` (path, string, required) the id of the catalog that the category belongs to  
    Minimum length: 1.
*   `category_id` (path, string, required) the id of the category requested  
    Minimum length: 1. Maximum length: 256.
*   `levels` (query, integer (int32)) Specifies how many levels of nested sub-categories you want the server to return. The default value is 1.  
    Minimum: 0.
*   `expand` (query, array of string) the expansion that client can use to specify and retrieve further information about the category (Internal use only for now).

#### Responses

*   **404** `CatalogNotFoundException` - Indicates that the catalog is not provided in the request. or `CategoryNotFoundException` - Indicates that the category does not exist for the catalog provided in the request.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `category`.
    

### PUT Create Category

`PUT /catalogs/{catalog_id}/categories/{category_id}`

Operation ID: `Create Category`. Tags: catalogs. Security: oauth2\_application.

Creates a catalog category using the information provided.

This endpoint may return the following faults:

*   400 - CategoryInvalidException - Indicates that the category in the request is not valid (the argument indicates the field that was invalid).
*   400 - IdConflictException - Indicates that the category ID in the request URL does not match the category ID in the request body.
*   404 - CatalogNotFoundException - Indicates that the catalog is not provided in the request.

#### Parameters

*   `catalog_id` (path, string, required) The id of the catalog.  
    Minimum length: 1.
*   `category_id` (path, string, required) The id of the category to be created  
    Minimum length: 1. Maximum length: 256.

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `category`.

#### Responses

*   **400** `CategoryInvalidException` - Indicates that the category in the request is not valid (the argument indicates the field that was invalid). or `IdConflictException` - Indicates that the category ID in the request URL does not match the category ID in the request body.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `CatalogNotFoundException` - Indicates that the catalog is not provided in the request.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `category`.
    

### DELETE Delete Category

`DELETE /catalogs/{catalog_id}/categories/{category_id}`

Operation ID: `Delete Category`. Tags: catalogs. Security: oauth2\_application.

Deletes the category by catalog ID and category ID

This endpoint may return the following faults:

*   404 - CatalogNotFoundException - Indicates that the catalog is not provided in the request.
*   404 - CategoryNotFoundException - Indicates that the category does not exist for the catalog provided in the request.

#### Parameters

*   `catalog_id` (path, string, required) The site context.  
    Minimum length: 1.
*   `category_id` (path, string, required) The category id to remove  
    Minimum length: 1.

#### Responses

*   **204**
*   **404** `CatalogNotFoundException` - Indicates that the catalog is not provided in the request. or `CategoryNotFoundException` - Indicates that the category does not exist for the catalog provided in the request.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    

### PATCH Update Category

`PATCH /catalogs/{catalog_id}/categories/{category_id}`

Operation ID: `Update Category`. Tags: catalogs. Security: oauth2\_application.

Updates a catalog category using the information provided.

This endpoint may return the following faults:

*   400 - CategoryInvalidException - Indicates that the category in the request is not valid (the argument indicates the field that was invalid).
*   404 - CatalogNotFoundException - Indicates that the catalog is not provided in the request.
*   404 - CategoryNotFoundException - Indicates that the category does not exist for the catalog provided in the request.

#### Parameters

*   `catalog_id` (path, string, required) The id of the catalog.  
    Minimum length: 1.
*   `category_id` (path, string, required) The id of the category  
    Minimum length: 1. Maximum length: 256.

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `category`.

#### Responses

*   **400** `CategoryInvalidException` - Indicates that the category in the request is not valid (the argument indicates the field that was invalid).
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `CatalogNotFoundException` - Indicates that the catalog is not provided in the request. or `CategoryNotFoundException` - Indicates that the category does not exist for the catalog provided in the request.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `category`.
    

### GET Get Category Links

`GET /catalogs/{catalog_id}/categories/{category_id}/category_links`

Operation ID: `Get Category Links`. Tags: catalogs. Security: oauth2\_application.

Action to get a set of outgoing category links in a given catalog category, sorted by position.

This endpoint may return the following faults:

*   404 - CatalogNotFoundException - Thrown in case the source catalog does not exist
*   404 - CategoryNotFoundException - Thrown in case the source category does not exist

#### Parameters

*   `catalog_id` (path, string, required) The id of the catalog.  
    Minimum length: 1.
*   `category_id` (path, string, required) The id of the source category.  
    Minimum length: 1.
*   `start` (query, integer (int32))
*   `count` (query, integer (int32))
*   `select` (query, string) Optional select clause for getting fields from the returned JSON document.

#### Responses

*   **404** `CatalogNotFoundException` - Thrown in case the source catalog does not exist or `CategoryNotFoundException` - Thrown in case the source category does not exist
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `category_links`.
    

### GET Get Category Link

`GET /catalogs/{catalog_id}/categories/{category_id}/category_links/{target_catalog_id}/{target_category_id}/{type}`

Operation ID: `Get Category Link`. Tags: catalogs. Security: oauth2\_application.

Action to get category link information.

This endpoint may return the following faults:

*   404 - CatalogNotFoundException - Thrown in case the source catalog or the target catalog do not exist
*   404 - CategoryLinkNotFoundException - Thrown in case the category link does not exist from the source catalog/category to the destination catalog/category with the given type.
*   404 - CategoryNotFoundException - Thrown in case the source category or the target category do not exist

#### Parameters

*   `catalog_id` (path, string, required) The id of the source catalog.  
    Minimum length: 1.
*   `category_id` (path, string, required) The id of the source category.  
    Minimum length: 1.
*   `target_catalog_id` (path, string, required) The id of the target catalog.  
    Minimum length: 1.
*   `target_category_id` (path, string, required) The id of the target category.  
    Minimum length: 1.
*   `type` (path, string, required) the link type
*   `select` (query, string) Optional select clause for getting fields from the returned JSON document.

#### Responses

*   **404** `CatalogNotFoundException` - Thrown in case the source catalog or the target catalog do not exist or `CategoryLinkNotFoundException` - Thrown in case the category link does not exist from the source catalog/category to the destination catalog/category with the given type. or `CategoryNotFoundException` - Thrown in case the source category or the target category do not exist
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `category_link`.
    

### PUT Create Category Link

`PUT /catalogs/{catalog_id}/categories/{category_id}/category_links/{target_catalog_id}/{target_category_id}/{type}`

Operation ID: `Create Category Link`. Tags: catalogs. Security: oauth2\_application.

Creates a category link using the information provided. If a category link with the same unique identifier, it will be updated with the new position.

This endpoint may return the following faults:

*   404 - CatalogNotFoundException - Thrown in case the source catalog or the target catalog do not exist
*   404 - CategoryNotFoundException - Thrown in case the source category or the target category do not exist

#### Parameters

*   `catalog_id` (path, string, required) The id of the source catalog.  
    Minimum length: 1.
*   `category_id` (path, string, required) The id of the source category.  
    Minimum length: 1.
*   `target_catalog_id` (path, string, required) The id of the target catalog.  
    Minimum length: 1.
*   `target_category_id` (path, string, required) The id of the target category.  
    Minimum length: 1.
*   `type` (path, string, required) the link type

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `category_link`.

#### Responses

*   **404** `CatalogNotFoundException` - Thrown in case the source catalog or the target catalog do not exist or `CategoryNotFoundException` - Thrown in case the source category or the target category do not exist
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `category_link`.
    

### DELETE Delete Category Link

`DELETE /catalogs/{catalog_id}/categories/{category_id}/category_links/{target_catalog_id}/{target_category_id}/{type}`

Operation ID: `Delete Category Link`. Tags: catalogs. Security: oauth2\_application.

Deletes the category link by ID

This endpoint may return the following faults:

*   404 - CatalogNotFoundException - Thrown in case the source catalog or the target catalog do not exist
*   404 - CategoryLinkNotFoundException - Thrown in case the category link does not exist from the source catalog/category to the destination catalog/category with the given type.
*   404 - CategoryNotFoundException - Thrown in case the source category or the target category do not exist

#### Parameters

*   `catalog_id` (path, string, required) The id of the source catalog.  
    Minimum length: 1.
*   `category_id` (path, string, required) The id of the source category.  
    Minimum length: 1.
*   `target_catalog_id` (path, string, required) The id of the target catalog.  
    Minimum length: 1.
*   `target_category_id` (path, string, required) The id of the target category.  
    Minimum length: 1.
*   `type` (path, string, required) the link type

#### Responses

*   **204**
*   **404** `CatalogNotFoundException` - Thrown in case the source catalog or the target catalog do not exist or `CategoryLinkNotFoundException` - Thrown in case the category link does not exist from the source catalog/category to the destination catalog/category with the given type. or `CategoryNotFoundException` - Thrown in case the source category or the target category do not exist
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    

### PATCH Update Category Link

`PATCH /catalogs/{catalog_id}/categories/{category_id}/category_links/{target_catalog_id}/{target_category_id}/{type}`

Operation ID: `Update Category Link`. Tags: catalogs. Security: oauth2\_application.

Updates the category link with the specified information.

This endpoint may return the following faults:

*   404 - CatalogNotFoundException - Thrown in case the source catalog or the target catalog do not exist
*   404 - CategoryLinkNotFoundException - Thrown in case the category link does not exist from the source catalog/category to the destination catalog/category with the given type.
*   404 - CategoryNotFoundException - Thrown in case the source category or the target category do not exist

#### Parameters

*   `catalog_id` (path, string, required) The id of the source catalog.  
    Minimum length: 1.
*   `category_id` (path, string, required) The id of the source category.  
    Minimum length: 1.
*   `target_catalog_id` (path, string, required) The id of the target catalog.  
    Minimum length: 1.
*   `target_category_id` (path, string, required) The id of the target category.  
    Minimum length: 1.
*   `type` (path, string, required) the link type

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `category_link`.

#### Responses

*   **404** `CatalogNotFoundException` - Thrown in case the source catalog or the target catalog do not exist or `CategoryLinkNotFoundException` - Thrown in case the category link does not exist from the source catalog/category to the destination catalog/category with the given type. or `CategoryNotFoundException` - Thrown in case the source category or the target category do not exist
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `category_link`.
    

### POST Search Category Product Assignment

`POST /catalogs/{catalog_id}/categories/{category_id}/category_product_assignment_search`

Operation ID: `Search Category Product Assignment`. Tags: catalogs. Security: oauth2\_application.

Searches for category product assignments.

The query attribute specifies a complex query that can be used to narrow down the search. This is the list of searchable attributes:

*   product\_id - String
    
*   product\_name - String
    
*   online\_flag - Boolean
    
*   searchable - Boolean
    
*   valid\_from - DateTime
    
*   valid\_to - DateTime
    
*   creation\_date - DateTime
    

Sortable Fields:

*   product\_id - String
    
*   product\_name - String
    
*   position - Double
    
*   creation\_date - DateTime
    

Expansions that can be applied for the search request:

*   product\_base - String - This expand will enable retrieval of the following basic **Product** information:
    
*   product\_images - String - to fetch preview image and image groups specified for the given product
    
*   product\_all\_images - String - to fetch preview image and image groups specified for the product plus images for its variants and variation groups
    
*   product\_variations - String to fetch variations related information, version 17.8+
    
*   product\_availability - String to fetch availability related information, version 17.8+
    
*   product\_categories - String to fetch category related information, version 17.8+
    
*   product\_prices - String to fetch prices related information, version 17.8+
    
*   product\_options - String to fetch options related information, version 17.8+
    
*   product\_all - String to fetch all expanded information, version 17.8+
    
    *   brand
        
    *   ean
        
    *   link
        
    *   long\_description
        
    *   manufacturer\_name
        
    *   manufacturer\_sku
        
    *   name
        
    *   page\_description
        
    *   page\_keywords
        
    *   page\_title
        
    *   searchable
        
    *   short\_description
        
    *   type
        
    *   unit
        
    *   upc
        

This endpoint may return the following faults:

*   400 - MalformedSearchParameterException - Thrown if the query is ill-formed.
*   404 - CatalogNotFoundException - Thrown if the catalog does not exist matching the given category\_id.
*   404 - CategoryNotFoundException - Thrown if the category does not exist matching the given catalog\_id.

#### Parameters

*   `catalog_id` (path, string, required) The id of the catalog.  
    Minimum length: 1.
*   `category_id` (path, string, required) The id of the category.  
    Minimum length: 1.
*   `site_id` (query, string) The site context.

#### Request body

Media type: `application/json, text/xml`. Schema: `category_product_assignment_search_request`.

#### Responses

*   **400** `MalformedSearchParameterException` - Thrown if the query is ill-formed.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `CatalogNotFoundException` - Thrown if the catalog does not exist matching the given category\_id. or `CategoryNotFoundException` - Thrown if the category does not exist matching the given catalog\_id.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `category_product_assignment_search_result`.
    

### GET Get Category Product Assignment

`GET /catalogs/{catalog_id}/categories/{category_id}/products/{product_id}`

Operation ID: `Get Category Product Assignment`. Tags: catalogs. Security: oauth2\_application.

Retrieves category product assignment information.

Expands that can be applied for the get request

*   product\_base - String
    
*   product\_images - String - to fetch image groups specified for the given product
    
*   product\_all\_images - String - to fetch image groups specified for the given product plus images for its variants and variation groups
    

This endpoint may return the following faults:

*   404 - CatalogNotFoundException - Thrown if the catalog does not exist matching the given id.
*   404 - CategoryNotFoundException - Thrown if the category does not exist matching the given id.
*   404 - CategoryProductAssignmentNotFoundException - Thrown if the category product assignment does not exist matching the given ids.
*   404 - ProductNotFoundException - Thrown if the product does not exist matching the given id.

#### Parameters

*   `catalog_id` (path, string, required) The catalog of the assignment.  
    Minimum length: 1.
*   `category_id` (path, string, required) The id of the requested category.  
    Minimum length: 1.
*   `product_id` (path, string, required) The id (SKU) of the requested assigned product.  
    Minimum length: 1.
*   `site_id` (query, string) The site context.
*   `expand` (query, array of string) The List of expansion values applied to the product associated to the assignment.
*   `select` (query, string) The selector for the get. If not passed, then the defaultSelector will be used instead.

#### Responses

*   **404** `CatalogNotFoundException` - Thrown if the catalog does not exist matching the given id. or `CategoryNotFoundException` - Thrown if the category does not exist matching the given id. or `CategoryProductAssignmentNotFoundException` - Thrown if the category product assignment does not exist matching the given ids. or `ProductNotFoundException` - Thrown if the product does not exist matching the given id.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `category_product_assignment`.
    

### PUT Create Category Product Assignment

`PUT /catalogs/{catalog_id}/categories/{category_id}/products/{product_id}`

Operation ID: `Create Category Product Assignment`. Tags: catalogs. Security: oauth2\_application.

**Creates** a category product assignment using the information provided;

As the assigned position n is a **normalized target position** , we'll make sure that the product is assigned to a position so that the order of positions are maintained.

For example, product A, B, C at position 1, 2, 3. product D is assigned to position 2, the end result is A, D, B, C with order of positions 1, 2, 3, 4;

If there are n existing positioned assignment, assigning a new product to position >= n+1 will end with new assignment with position n+1.

This endpoint may return the following faults:

*   400 - IdConflictException - if the Id in request is not the same as the ID in document.
*   404 - CatalogNotFoundException - Thrown if the catalog does not exist matching the given id.
*   404 - CategoryNotFoundException - Thrown if the category does not exist matching the given id.
*   404 - ProductNotFoundException - Thrown if the product does not exist matching the given id.

#### Parameters

*   `catalog_id` (path, string, required) The id of the requested catalog to which to assign the product.  
    Minimum length: 1.
*   `category_id` (path, string, required) The id of the requested category to which to assign the product.  
    Minimum length: 1.
*   `product_id` (path, string, required) The id (SKU) of the requested product to assign.  
    Minimum length: 1.

#### Request body

Media type: `application/json, text/xml`. Schema: `category_product_assignment`.

#### Responses

*   **400** `IdConflictException` - if the Id in request is not the same as the ID in document.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `CatalogNotFoundException` - Thrown if the catalog does not exist matching the given id. or `CategoryNotFoundException` - Thrown if the category does not exist matching the given id. or `ProductNotFoundException` - Thrown if the product does not exist matching the given id.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `category_product_assignment`.
    

### DELETE Delete Category Product Assignment

`DELETE /catalogs/{catalog_id}/categories/{category_id}/products/{product_id}`

Operation ID: `Delete Category Product Assignment`. Tags: catalogs. Security: oauth2\_application.

**Removes** a category product assignment;

For example, if we have products A, B, C at positions 1, 2, 7.5 and delete assignment for product B, this will end up the products A, B, C at positions 1, null, 7.5.

This endpoint may return the following faults:

*   404 - CatalogNotFoundException - Thrown if the catalog does not exist matching the given id.
*   404 - CategoryNotFoundException - Thrown if the category does not exist matching the given id.

#### Parameters

*   `catalog_id` (path, string, required) The catalog of the assignment.  
    Minimum length: 1.
*   `category_id` (path, string, required) The id of the requested category.  
    Minimum length: 1.
*   `product_id` (path, string, required) The id of the requested product to un-assign.  
    Minimum length: 1.

#### Responses

*   **204**
*   **404** `CatalogNotFoundException` - Thrown if the catalog does not exist matching the given id. or `CategoryNotFoundException` - Thrown if the category does not exist matching the given id.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    

### PATCH Update Category Product Assignment

`PATCH /catalogs/{catalog_id}/categories/{category_id}/products/{product_id}`

Operation ID: `Update Category Product Assignment`. Tags: catalogs. Security: oauth2\_application.

**Updates** the category product assignment with the specified information, such as position.

As the assigned position n is a **normalized target position** , we'll make sure that the product is assigned to a position so that the order of positions are maintained.

For example, if we have products A, B, C, D at positions 1, 2, 3, 4 and update product A with new position 3, the end result is B, C, A, D with order of positions 1, 2, 3, 4.

If we then update product C to no position, the end result is B, A, D, C with order of positions 1, 2, 3, null.

If there are n existing positioned assignment, updating product to position > = n will end with new assignment with position such that the order of positions is maintained.

This endpoint may return the following faults:

*   404 - CatalogNotFoundException - Thrown if the catalog does not exist matching the given id.
*   404 - CategoryNotFoundException - Thrown if the category does not exist matching the given id.
*   404 - CategoryProductAssignmentNotFoundException - Thrown if the category product assignment does not exist.
*   404 - ProductNotFoundException - Thrown if the product does not exist matching the given id.

#### Parameters

*   `catalog_id` (path, string, required) The id of the requested catalog to which the product is assigned.  
    Minimum length: 1.
*   `category_id` (path, string, required) The id of the requested category to which the product is assigned.  
    Minimum length: 1.
*   `product_id` (path, string, required) The id (SKU) of the requested assigned product.  
    Minimum length: 1.

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `category_product_assignment`.

#### Responses

*   **404** `CatalogNotFoundException` - Thrown if the catalog does not exist matching the given id. or `CategoryNotFoundException` - Thrown if the category does not exist matching the given id. or `CategoryProductAssignmentNotFoundException` - Thrown if the category product assignment does not exist. or `ProductNotFoundException` - Thrown if the product does not exist matching the given id.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `category_product_assignment`.
    

### POST Search Categories within a Catalog

`POST /catalogs/{catalog_id}/category_search`

Operation ID: `Search Categories within a Catalog`. Tags: catalogs. Security: oauth2\_application.

Searches for catalog categories in the scope of catalog

By default, the server also returns the first level of subcategories, but you can specify another level by setting the levels parameter. Please note, using a large value for levels may cause performance issues in case of a large and deep category tree.

The query attribute specifies a complex query that can be used to narrow down the search. These are the list of searchable attributes:

*   id - String
    
*   name - String
    
*   description - String
    
*   creation\_date - DateTime
    
*   online - Boolean
    
*   parent\_category\_id - String
    

The output of the query can also be sorted. These are the list of sortable attributes:

*   id - String
    
*   name - String
    
*   description - String
    
*   creation\_date - DateTime
    
*   online - Boolean
    
*   position - Double
    

This endpoint may return the following faults:

*   400 - MalformedSearchParameterException - Thrown if the query is ill-formed.
*   404 - CatalogNotFoundException - Thrown if the specified catalog does not exist.

#### Parameters

*   `catalog_id` (path, string, required) The id of the catalog.  
    Minimum length: 1. Maximum length: 256.
*   `levels` (query, integer (int32))  
    Minimum: 0.

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `search_request`.

#### Responses

*   **400** `MalformedSearchParameterException` - Thrown if the query is ill-formed.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `CatalogNotFoundException` - Thrown if the specified catalog does not exist.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `category_search_result`.
    

### GET Get Shared Product Options

`GET /catalogs/{catalog_id}/shared_product_options`

Operation ID: `Get Shared Product Options`. Tags: catalogs. Security: oauth2\_application.

Read shared product options in a catalog.

This endpoint may return the following faults:

*   404 - CatalogNotFoundException - Indicates the catalog is not found.

#### Parameters

*   `catalog_id` (path, string, required) The id of the catalog.  
    Minimum length: 1.
*   `start` (query, integer (int32)) Optional start index for retrieving the items from a given index (default 0).
*   `count` (query, integer (int32)) Optional count for retrieving only a subset of the items (default is 25).
*   `select` (query, string) The property selector.
*   `currency` (query, string) The currency mnemonic for retrieving the product option values according to the sorting mode.ex:'USD'

#### Responses

*   **404** `CatalogNotFoundException` - Indicates the catalog is not found.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `product_options`.
    

### GET Get Product option

`GET /catalogs/{catalog_id}/shared_product_options/{id}`

Operation ID: `Get Product option`. Tags: catalogs. Security: oauth2\_application.

Read a shared product option in a catalog.

This endpoint may return the following faults:

*   404 - CatalogNotFoundException - Indicates the catalog is not found.
*   404 - ProductOptionNotFoundException - Indicates the shared product option is not found.

#### Parameters

*   `catalog_id` (path, string, required) The id of the catalog.  
    Minimum length: 1.
*   `id` (path, string, required) The id of the shared product option.  
    Minimum length: 1.
*   `currency` (query, string) The currency mnemonic for retrieving the product option values according to the sorting mode.ex:'USD'

#### Responses

*   **404** `CatalogNotFoundException` - Indicates the catalog is not found. or `ProductOptionNotFoundException` - Indicates the shared product option is not found.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `product_option`.
    

### PUT Create Shared Product Option

`PUT /catalogs/{catalog_id}/shared_product_options/{id}`

Operation ID: `Create Shared Product Option`. Tags: catalogs. Security: oauth2\_application.

Creates a shared product option using the information provided.

This endpoint may return the following faults:

*   400 - ProductOptionDuplicateException - Indicates the shared product option is a duplicate.
*   500 - AttributeDefinitionNotFoundException - Indicates the id specified is not a valid attribute definition.
*   404 - CatalogNotFoundException - Indicates the catalog is not found.

#### Parameters

*   `catalog_id` (path, string, required) The id of the catalog.  
    Minimum length: 1.
*   `id` (path, string, required) The id of the shared product option.  
    Minimum length: 1.

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `product_option`.

#### Responses

*   **400** `ProductOptionDuplicateException` - Indicates the shared product option is a duplicate.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `CatalogNotFoundException` - Indicates the catalog is not found.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **500** `AttributeDefinitionNotFoundException` - Indicates the id specified is not a valid attribute definition.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `product_option`.
    

### DELETE Delete Shared Product Option

`DELETE /catalogs/{catalog_id}/shared_product_options/{id}`

Operation ID: `Delete Shared Product Option`. Tags: catalogs. Security: oauth2\_application.

Deletes a shared product option by ID.

This endpoint may return the following faults:

*   404 - CatalogNotFoundException - Indicates the catalog is not found.
*   404 - ProductOptionNotFoundException - Indicates the shared product option is not found.

#### Parameters

*   `catalog_id` (path, string, required) The id of the catalog.  
    Minimum length: 1.
*   `id` (path, string, required) The id of the shared product option.

#### Responses

*   **204**
*   **404** `CatalogNotFoundException` - Indicates the catalog is not found. or `ProductOptionNotFoundException` - Indicates the shared product option is not found.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    

### PATCH Update Shared Product Option

`PATCH /catalogs/{catalog_id}/shared_product_options/{id}`

Operation ID: `Update Shared Product Option`. Tags: catalogs. Security: oauth2\_application.

Updates a shared product option with the information provided.

This endpoint may return the following faults:

*   404 - CatalogNotFoundException - Indicates the catalog is not found.
*   404 - ProductOptionNotFoundException - Indicates the shared product option is not found.

#### Parameters

*   `catalog_id` (path, string, required) The id of the catalog.  
    Minimum length: 1.
*   `id` (path, string, required) The id of the shared product option.  
    Minimum length: 1.

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `product_option`.

#### Responses

*   **404** `CatalogNotFoundException` - Indicates the catalog is not found. or `ProductOptionNotFoundException` - Indicates the shared product option is not found.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `product_option`.
    

### GET Get Shared Product Option Values

`GET /catalogs/{catalog_id}/shared_product_options/{option_id}/values`

Operation ID: `Get Shared Product Option Values`. Tags: catalogs. Security: oauth2\_application.

Read shared product option values of a shared product option in a catalog.

This endpoint may return the following faults:

*   404 - CatalogNotFoundException - Indicates the catalog is not found.
*   404 - ProductOptionNotFoundException - Indicates the shared product option is not found.

#### Parameters

*   `catalog_id` (path, string, required) The id of the catalog.  
    Minimum length: 1.
*   `option_id` (path, string, required) The id of the shared product option.  
    Minimum length: 1.
*   `start` (query, integer (int32)) Optional start index for retrieving the items from a given index (default 0).
*   `count` (query, integer (int32)) Optional count for retrieving only a subset of the items (default is 25).
*   `select` (query, string) The property selector.

#### Responses

*   **404** `CatalogNotFoundException` - Indicates the catalog is not found. or `ProductOptionNotFoundException` - Indicates the shared product option is not found.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `product_option_values`.
    

### GET Get Shared Product Option Value

`GET /catalogs/{catalog_id}/shared_product_options/{option_id}/values/{id}`

Operation ID: `Get Shared Product Option Value`. Tags: catalogs. Security: oauth2\_application.

Read a shared product option value of a shared product option in a catalog.

This endpoint may return the following faults:

*   404 - CatalogNotFoundException - Indicates the catalog is not found.
*   404 - ProductOptionNotFoundException - Indicates the shared product option is not found.
*   404 - ProductOptionValueNotFoundException - Indicates the shared product option value is not found.

#### Parameters

*   `catalog_id` (path, string, required) The id of the catalog.  
    Minimum length: 1.
*   `option_id` (path, string, required) The id of the shared product option.  
    Minimum length: 1.
*   `id` (path, string, required) the id of shared product option value.  
    Minimum length: 1.

#### Responses

*   **404** `CatalogNotFoundException` - Indicates the catalog is not found. or `ProductOptionNotFoundException` - Indicates the shared product option is not found. or `ProductOptionValueNotFoundException` - Indicates the shared product option value is not found.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `product_option_value`.
    

### PUT Create Shared Product Option Value

`PUT /catalogs/{catalog_id}/shared_product_options/{option_id}/values/{id}`

Operation ID: `Create Shared Product Option Value`. Tags: catalogs. Security: oauth2\_application.

Creates a shared product option value using the information provided.

This endpoint may return the following faults:

*   404 - CatalogNotFoundException - Indicates the catalog is not found.
*   404 - ProductOptionNotFoundException - Indicates the shared product option is not found.

#### Parameters

*   `catalog_id` (path, string, required) The id of the catalog.  
    Minimum length: 1.
*   `option_id` (path, string, required) The id of the shared product option.  
    Minimum length: 1.
*   `id` (path, string, required) The id of the shared product option value.  
    Minimum length: 1.

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `product_option_value`.

#### Responses

*   **404** `CatalogNotFoundException` - Indicates the catalog is not found. or `ProductOptionNotFoundException` - Indicates the shared product option is not found.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `product_option_value`.
    

### DELETE Delete Shared Product Option Value

`DELETE /catalogs/{catalog_id}/shared_product_options/{option_id}/values/{id}`

Operation ID: `Delete Shared Product Option Value`. Tags: catalogs. Security: oauth2\_application.

Deletes a shared product option value by ID.

This endpoint may return the following faults:

*   404 - CatalogNotFoundException - Indicates the catalog is not found.
*   404 - ProductOptionNotFoundException - Indicates the shared product option is not found.
*   404 - ProductOptionValueNotFoundException - Indicates the shared product option value is not found.

#### Parameters

*   `catalog_id` (path, string, required) The id of the catalog.  
    Minimum length: 1.
*   `option_id` (path, string, required) The id of the shared product option.  
    Minimum length: 1.
*   `id` (path, string, required) The id of the shared product option value.

#### Responses

*   **204**
*   **404** `CatalogNotFoundException` - Indicates the catalog is not found. or `ProductOptionNotFoundException` - Indicates the shared product option is not found. or `ProductOptionValueNotFoundException` - Indicates the shared product option value is not found.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    

### PATCH Update Shared Product Option Value

`PATCH /catalogs/{catalog_id}/shared_product_options/{option_id}/values/{id}`

Operation ID: `Update Shared Product Option Value`. Tags: catalogs. Security: oauth2\_application.

Updates a shared product option value with the information provided.

This endpoint may return the following faults:

*   404 - CatalogNotFoundException - Indicates the catalog is not found.
*   404 - ProductOptionNotFoundException - Indicates the shared product option is not found.
*   404 - ProductOptionValueNotFoundException - Indicates the shared product option value is not found.

#### Parameters

*   `catalog_id` (path, string, required) The id of the catalog.  
    Minimum length: 1.
*   `option_id` (path, string, required) The id of the shared product option.  
    Minimum length: 1.
*   `id` (path, string, required) The id of the shared product option value.  
    Minimum length: 1.

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `product_option_value`.

#### Responses

*   **404** `CatalogNotFoundException` - Indicates the catalog is not found. or `ProductOptionNotFoundException` - Indicates the shared product option is not found. or `ProductOptionValueNotFoundException` - Indicates the shared product option value is not found.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `product_option_value`.
    

### GET Get shared Variation Attributes

`GET /catalogs/{catalog_id}/shared_variation_attributes`

Operation ID: `Get shared Variation Attributes`. Tags: catalogs. Security: oauth2\_application.

Reads variation attributes of a Domain.

This endpoint may return the following faults:

*   404 - CatalogNotFoundException - Indicates the catalog is not found.

#### Parameters

*   `catalog_id` (path, string, required) id of the catalog.  
    Minimum length: 1.
*   `start` (query, integer (int32))
*   `count` (query, integer (int32))
*   `select` (query, string)

#### Responses

*   **404** `CatalogNotFoundException` - Indicates the catalog is not found.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `variation_attributes`.
    

### GET Get Shared Variation Attribute Values

`GET /catalogs/{catalog_id}/shared_variation_attributes/{attribute_id}/values`

Operation ID: `Get Shared Variation Attribute Values`. Tags: catalogs. Security: oauth2\_application.

Reads variation attribute values of a variation attribute of a catalog.

This endpoint may return the following faults:

*   404 - CatalogNotFoundException - Indicates the catalog is not found.
*   404 - VariationAttributeNotFoundException - Indicate the variation attribute is not found

#### Parameters

*   `catalog_id` (path, string, required) id of the owning catalog.  
    Minimum length: 1.
*   `attribute_id` (path, string, required) The variation attribute ID that contains the values.  
    Minimum length: 1.
*   `start` (query, integer (int32)) the first record to get in the page
*   `count` (query, integer (int32)) the number of records to get
*   `select` (query, string) a string that specifies which fields to return (default is all).

#### Responses

*   **404** `CatalogNotFoundException` - Indicates the catalog is not found. or `VariationAttributeNotFoundException` - Indicate the variation attribute is not found
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `variation_attribute_values`.
    

### GET Get Shared Variation Attribute Value

`GET /catalogs/{catalog_id}/shared_variation_attributes/{attribute_id}/values/{id}`

Operation ID: `Get Shared Variation Attribute Value`. Tags: catalogs. Security: oauth2\_application.

Action to get Shared Variation Attribute value information.

This endpoint may return the following faults:

*   404 - CatalogNotFoundException - Indicates the catalog is not found.
*   404 - VariationAttributeNotFoundException - Indicate the variation attribute is not found
*   404 - VariationAttributeValueNotFoundException - Indicate the variation attribute value is not found

#### Parameters

*   `catalog_id` (path, string, required) The owning catalog ID.  
    Minimum length: 1.
*   `attribute_id` (path, string, required) The variation attribute custom ID  
    Minimum length: 1.
*   `id` (path, string, required) The id of the variation attribute value  
    Minimum length: 1.

#### Responses

*   **404** `CatalogNotFoundException` - Indicates the catalog is not found. or `VariationAttributeNotFoundException` - Indicate the variation attribute is not found or `VariationAttributeValueNotFoundException` - Indicate the variation attribute value is not found
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `variation_attribute_value`.
    

### PUT Put Shared Variation Attribute Value

`PUT /catalogs/{catalog_id}/shared_variation_attributes/{attribute_id}/values/{id}`

Operation ID: `Put Shared Variation Attribute Value`. Tags: catalogs. Security: oauth2\_application.

Action to create a Shared Variation Attribute value.

This endpoint may return the following faults:

*   404 - CatalogNotFoundException - Indicates the catalog is not found.
*   404 - VariationAttributeNotFoundException - Indicate the variation attribute is not found
*   404 - VariationAttributeValueNotFoundException - Indicate the variation attribute value is not found

#### Parameters

*   `catalog_id` (path, string, required) The owning catalog ID.  
    Minimum length: 1.
*   `attribute_id` (path, string, required) The variation attribute ID  
    Minimum length: 1.
*   `id` (path, string, required) The id of the variation attribute value  
    Minimum length: 1.

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `variation_attribute_value`.

#### Responses

*   **404** `CatalogNotFoundException` - Indicates the catalog is not found. or `VariationAttributeNotFoundException` - Indicate the variation attribute is not found or `VariationAttributeValueNotFoundException` - Indicate the variation attribute value is not found
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `variation_attribute_value`.
    

### DELETE Delete Shared Variation Attribute Value

`DELETE /catalogs/{catalog_id}/shared_variation_attributes/{attribute_id}/values/{id}`

Operation ID: `Delete Shared Variation Attribute Value`. Tags: catalogs. Security: oauth2\_application.

Deletes the variation attribute value of a variation attribute bound to a catalog

This endpoint may return the following faults:

*   404 - CatalogNotFoundException - if the catalog id specified cannot be found
*   404 - VariationAttributeNotFoundException - if the attribute id specified is not a valid variation attribute
*   404 - VariationAttributeValueNotFoundException - if the value id specified does not a valid value id

#### Parameters

*   `catalog_id` (path, string, required) The id of the catalog.  
    Minimum length: 1.
*   `attribute_id` (path, string, required) The id of the variation attribute that contains the value.  
    Minimum length: 1.
*   `id` (path, string, required) The id of one value to remove

#### Responses

*   **204**
*   **404** `CatalogNotFoundException` - if the catalog id specified cannot be found or `VariationAttributeNotFoundException` - if the attribute id specified is not a valid variation attribute or `VariationAttributeValueNotFoundException` - if the value id specified does not a valid value id
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    

### PATCH Update Shared Variation Attribute Value

`PATCH /catalogs/{catalog_id}/shared_variation_attributes/{attribute_id}/values/{id}`

Operation ID: `Update Shared Variation Attribute Value`. Tags: catalogs. Security: oauth2\_application.

Updates the variation attribute value of a variation attribute of a catalog.

This endpoint may return the following faults:

*   404 - CatalogNotFoundException - if the catalog id specified cannot be found
*   404 - VariationAttributeNotFoundException - if the attribute id specified is not a valid variation attribute
*   404 - VariationAttributeValueNotFoundException - if the value id specified does not a valid value id

#### Parameters

*   `catalog_id` (path, string, required) The id of the catalog.  
    Minimum length: 1.
*   `attribute_id` (path, string, required) The id of the requested variation attribute.  
    Minimum length: 1.
*   `id` (path, string, required) The id of the variation value.  
    Minimum length: 1.

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `variation_attribute_value`.

#### Responses

*   **404** `CatalogNotFoundException` - if the catalog id specified cannot be found or `VariationAttributeNotFoundException` - if the attribute id specified is not a valid variation attribute or `VariationAttributeValueNotFoundException` - if the value id specified does not a valid value id
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `variation_attribute_value`.
    

### GET Get shared Variation Attribute

`GET /catalogs/{catalog_id}/shared_variation_attributes/{id}`

Operation ID: `Get shared Variation Attribute`. Tags: catalogs. Security: oauth2\_application.

Action to get shared variation attribute information only for master Catalog.

This endpoint may return the following faults:

*   404 - CatalogNotFoundException - Indicates the catalog is not found.
*   404 - VariationAttributeNotFoundException - Thrown if the variation attribute matching the given id does not exist.

#### Parameters

*   `catalog_id` (path, string, required) The id of the catalog.  
    Minimum length: 1.
*   `id` (path, string, required) The id of the requested variation attribute.  
    Minimum length: 1.

#### Responses

*   **404** `CatalogNotFoundException` - Indicates the catalog is not found. or `VariationAttributeNotFoundException` - Thrown if the variation attribute matching the given id does not exist.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `variation_attribute`.
    

### PUT Create shared Variation Attribute

`PUT /catalogs/{catalog_id}/shared_variation_attributes/{id}`

Operation ID: `Create shared Variation Attribute`. Tags: catalogs. Security: oauth2\_application.

Creates a shared variation attribute using the information provided. To create a variation attribute specific to a product, use the products resource.

This endpoint may return the following faults:

*   400 - SharedVariationAttributeIDNotUniqueException - if the specified id isn't unique.
*   500 - AttributeDefinitionNotFoundException - if attribute definition supplied is not a product attribute.
*   404 - CatalogNotFoundException - Indicates the catalog is not found.

#### Parameters

*   `catalog_id` (path, string, required) The id of the catalog.  
    Minimum length: 1.
*   `id` (path, string, required) The id of the variation attribute to create.  
    Minimum length: 1.

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `variation_attribute`.

#### Responses

*   **400** `SharedVariationAttributeIDNotUniqueException` - if the specified id isn't unique.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `CatalogNotFoundException` - Indicates the catalog is not found.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **500** `AttributeDefinitionNotFoundException` - if attribute definition supplied is not a product attribute.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `variation_attribute`.
    

### DELETE Delete shared Variation Attribute

`DELETE /catalogs/{catalog_id}/shared_variation_attributes/{id}`

Operation ID: `Delete shared Variation Attribute`. Tags: catalogs. Security: oauth2\_application.

Deletes the shared variation attribute by ID.

This endpoint may return the following faults:

*   404 - CatalogNotFoundException - Indicates the catalog is not found.
*   404 - VariationAttributeNotFoundException - Thrown if the variation attribute does not exist.

#### Parameters

*   `catalog_id` (path, string, required) The id of the catalog.  
    Minimum length: 1.
*   `id` (path, string, required) One variation attribute id to remove.

#### Responses

*   **204**
*   **404** `CatalogNotFoundException` - Indicates the catalog is not found. or `VariationAttributeNotFoundException` - Thrown if the variation attribute does not exist.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    

### PATCH Update shared Variation Attribute

`PATCH /catalogs/{catalog_id}/shared_variation_attributes/{id}`

Operation ID: `Update shared Variation Attribute`. Tags: catalogs. Security: oauth2\_application.

Updates the shared variation attribute with the specified information.

*   name
    
*   slicing
    

This endpoint may return the following faults:

*   404 - CatalogNotFoundException - if the specified catalog id cannot be found.

#### Parameters

*   `catalog_id` (path, string, required) The id of the catalog.  
    Minimum length: 1.
*   `id` (path, string, required) The id of the requested variation attribute.  
    Minimum length: 1.

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `variation_attribute`.

#### Responses

*   **404** `CatalogNotFoundException` - if the specified catalog id cannot be found.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `variation_attribute`.
    

## Schemas

### catalogs

Document representing an unfiltered list of catalogs.

*   `count` (_integer (int32)_) The number of returned documents.
*   `data` (_array of catalog_) The collection of catalogs.
*   `expand` (_array of string_) The list of expands set for the search request. Expands are optional.
*   `next` (_string_) The URL of the next result page.
*   `previous` (_string_) The URL of the previous result page.
*   `select` (_string_) The fields that you want to select.
*   `start` (_integer (int32)_) The zero-based index of the first search hit to include in the result.  
    Minimum: 0.
*   `total` (_integer (int32)_) The total number of documents.

_Example_

```
{
  "count": 2,
  "data": [
    {
      "assigned_product_count": 22,
      "assigned_sites": [
        {
          "customer_list_link": {
            "customer_list_id": "list1"
          },
          "description": "Site's site used for test.",
          "display_name": "Test site 1",
          "id": "site-1"
        },
        {
          "customer_list_link": {
            "customer_list_id": "list2"
          },
          "description": "Site's site used for test 2.",
          "display_name": "Test site 2",
          "id": "site-2"
        }
      ],
      "category_count": 14,
      "creation_date": "2015-11-18T05:00:00.000Z",
      "description": {
        "de": "A German my-description",
        "default": "my-description",
        "en": "An English my-description"
      },
      "end_maintenance": "2015-9-20T05:00:00.000Z",
      "id": "my-catalog1",
      "is_master_catalog": false,
      "is_storefront_catalog": false,
      "link": "https://example.com/s/-/dw/data/{version}/catalogs/my-catalog1",
      "name": {
        "de": "A German my-name",
        "default": "my-name",
        "en": "An English my-name"
      },
      "online": true,
      "owned_product_count": 19,
      "recommendation_count": 20,
      "root_category": "my-root_category",
      "start_maintenance": "2015-7-22T05:00:00.000Z"
    },
    {
      "assigned_product_count": 22,
      "assigned_sites": [],
      "category_count": 14,
      "creation_date": "2015-11-18T05:00:00.000Z",
      "description": {
        "de": "A German my-description",
        "default": "my-description",
        "en": "An English my-description"
      },
      "end_maintenance": "2015-9-20T05:00:00.000Z",
      "id": "my-catalog2",
      "is_master_catalog": false,
      "is_storefront_catalog": false,
      "link": "https://example.com/s/-/dw/data/{version}/catalogs/my-catalog1",
      "name": {
        "de": "A German my-name",
        "default": "my-name",
        "en": "An English my-name"
      },
      "online": true,
      "owned_product_count": 19,
      "recommendation_count": 20,
      "root_category": "my-root_category",
      "start_maintenance": "2015-7-22T05:00:00.000Z"
    }
  ],
  "select": "**",
  "start": 0,
  "total": 2
}
```

### fault

Document representing a fault message that is returned whenever the HTTP status code is greater than or equal to 400 (which indicates an error).

*   `arguments` (_object_)
    
    A map that provides fault arguments.
    
    Data can be used to provide error messages on the client side.
    
    Additional properties: `object`.
    
*   `cause` (_cause_)
*   `display_message_pattern` (_string_) The localized display message pattern, if the request parameter display\_locale was given
*   `message` (_string_) The message text of the java exception.
*   `stack_trace` (_string_)
*   `type` (_string_) The name of the java exception.

### catalog

Document representing a catalog

*   `assigned_product_count` (_integer (int32)_) The count of products assigned to the catalog. It is read only.
*   `assigned_sites` (_array of site_) The sites assigned to the catalog. It is read only.
*   `category_count` (_integer (int32)_) The category count of catalog. It is read only.
*   `creation_date` (_string (date-time)_, read-only) Returns the value of attribute 'creationDate'.
*   `description` (_object (localized)_) The description of catalog
    
    Additional properties: `string`.
    
*   `id` (_string_) The catalog Id
*   `last_modified` (_string (date-time)_, read-only) Returns the value of attribute 'lastModified'.
*   `link` (_string_) URL that is used to get this instance. It is read only.
*   `name` (_object (localized)_) The catalog name
    
    Additional properties: `string`.
    
*   `online` (_boolean_) The online status of catalog
*   `owned_product_count` (_integer (int32)_) The count of products owned by the catalog. It is read only.
*   `recommendation_count` (_integer (int32)_) The recommendation count of the catalog. It is read only.
*   `root_category` (_string_) The root category of the catalog. It is read only

_Example_

```
{
  "assigned_product_count": 96,
  "assigned_sites": [
    {
      "customer_list_link": {
        "customer_list_id": "list1"
      },
      "description": "Site's site used for test.",
      "display_name": "Test site 1",
      "id": "site-1"
    },
    {
      "customer_list_link": {
        "customer_list_id": "list2"
      },
      "description": "Site's site used for test 2.",
      "display_name": "Test site 2",
      "id": "site-2"
    }
  ],
  "category_count": 37,
  "creation_date": "2015-10-02T14:16:08.000Z",
  "description": "My catalog.",
  "id": "my-catalog",
  "link": "https://example.com/s/-/dw/data/{version}/catalogs/my-catalog",
  "name": "My Catalog",
  "online": true,
  "owned_product_count": 148,
  "recommendation_count": 5,
  "root_category": "root"
}
```

### categories

Document representing an unfiltered list of categories.

*   `count` (_integer (int32)_) The number of returned documents.
*   `data` (_array of category_)
*   `expand` (_array of string_) The list of expands set for the search request. Expands are optional.
*   `next` (_string_) The URL of the next result page.
*   `previous` (_string_) The URL of the previous result page.
*   `select` (_string_) The fields that you want to select.
*   `start` (_integer (int32)_) The zero-based index of the first search hit to include in the result.  
    Minimum: 0.
*   `total` (_integer (int32)_) The total number of documents.

_Example_

```
{
  "count": 1,
  "data": [
    {
      "categories": [
        {
          "creation_date": "2015-11-30T18:48:37.333Z",
          "description": {
            "default": "sub-category 1 for main catalog"
          },
          "id": "sub-category-1",
          "image": "https://example.com/on/demandware.static/-/Sites-main-catalog/default/v1447965267239/category%201.1%20image",
          "link": "https://example.com/s/-/dw/data/{version}/catalogs/main-catalog/categories/sub-category-1",
          "name": {
            "default": "Sub-category 1"
          },
          "online": true,
          "parent_category_id": "root",
          "paths": [
            {
              "id": "sub-category-1",
              "name": {
                "default": "Sub-category 1"
              }
            }
          ],
          "position": 1,
          "thumbnail": "https://example.com/on/demandware.static/-/Sites-main-catalog/default/v1447965267239/category%201.1%20thumbnail"
        }
      ],
      "creation_date": "2015-11-29T18:48:37.333Z",
      "description": {
        "default": "root category for main catalog"
      },
      "id": "root",
      "image": "https://example.com/on/demandware.static/-/Sites-main-catalog/default/v1447965267239/category%201%20image",
      "link": "https://example.com/s/-/dw/data/{version}/catalogs/main-catalog/categories/root",
      "name": {
        "default": "Root Category"
      },
      "online": true,
      "paths": [
        {
          "id": "root",
          "name": {
            "default": "root"
          }
        }
      ],
      "position": 1,
      "sorting_rules": [
        {
          "creation_date": "2015-11-19T20:46:37.000Z",
          "description": "Sorts by price ascending",
          "id": "price-low-to-high",
          "product_sorting_rule_steps": [
            {
              "direction": "Ascending",
              "is_system": false,
              "position": 0,
              "text_relevance_included": false,
              "type_id": "price"
            }
          ],
          "site": "main-site"
        }
      ],
      "thumbnail": "https://example.com/on/demandware.static/-/Sites-main-catalog/default/v1447965267239/category%201%20thumbnail"
    }
  ],
  "select": "**",
  "start": 0,
  "total": 1
}
```

### category

Document representing a category.

*   `catalog_id` (_string_) The id of the catalog that contains it.
*   `categories` (_array of category_) The array of sub categories for the category.
*   `creation_date` (_string (date-time)_, read-only) Returns the value of attribute 'creationDate'.
*   `description` (_object (localized)_) The localized description of the category.
    
    Additional properties: `string`.
    
*   `id` (_string_) The id of the category.  
    Minimum length: 1. Maximum length: 256.
*   `image` (_string_) The name of the category image. The URL to the image is computed.  
    Minimum length: 1. Maximum length: 256.
*   `last_modified` (_string (date-time)_, read-only) Returns the value of attribute 'lastModified'.
*   `link` (_string_) The URL to get the category. This is a computed attribute and cannot be modified.
*   `name` (_object (localized)_) The localized name of the category.
    
    Additional properties: `string`.
    
*   `online` (_boolean_) The online status of the category determines if it is visible in the storefront. Defaults to false if not specified on create.
*   `page_description` (_object (localized)_) The localized page description of the category.
    
    Additional properties: `string`.
    
*   `page_keywords` (_object (localized)_) The localized page keywords for the category.
    
    Additional properties: `string`.
    
*   `page_title` (_object (localized)_) The localized page title of the category.
    
    Additional properties: `string`.
    
*   `parent_category_id` (_string_) The id of the parent category. Defaults to root if not specified on create.  
    Minimum length: 1. Maximum length: 256.
*   `paths` (_array of path\_record_)
*   `position` (_number (double)_) The position of the category determines the display order in the storefront.
*   `sorting_rules` (_array of sorting\_rule_)
*   `thumbnail` (_string_) The name of the category thumbnail. The URL to the thumbnail is computed.  
    Minimum length: 1. Maximum length: 256.

_Example_

```
{
  "categories": [
    {
      "creation_date": "2015-11-30T18:48:37.333Z",
      "description": {
        "default": "sub-category 1 for main catalog"
      },
      "id": "sub-category-1",
      "image": "https://example.com/on/demandware.static/-/Sites-main-catalog/default/v1447965267239/category%201.1%20image",
      "link": "https://example.com/s/-/dw/data/{version}/catalogs/main-catalog/categories/sub-category-1",
      "name": {
        "default": "Sub-category 1"
      },
      "online": true,
      "parent_category_id": "root",
      "paths": [
        {
          "id": "main-catalog",
          "name": {
            "default": "Main Catalog"
          }
        },
        {
          "id": "root",
          "name": {
            "default": "root category"
          }
        },
        {
          "id": "sub-category-1",
          "name": {
            "default": "Sub-category 1"
          }
        }
      ],
      "position": 1,
      "thumbnail": "https://example.com/on/demandware.static/-/Sites-main-catalog/default/v1447965267239/category%201.1%20thumbnail"
    },
    {
      "creation_date": "2015-12-02T18:48:37.333Z",
      "description": {
        "default": "sub-category 2 for main catalog"
      },
      "id": "sub-category-2",
      "image": "https://example.com/on/demandware.static/-/Sites-main-catalog/default/v1447965267239/category%201.1%20image",
      "link": "https://example.com/s/-/dw/data/{version}/catalogs/main-catalog/categories/sub-category-2",
      "name": {
        "default": "Sub-category 2"
      },
      "online": true,
      "parent_category_id": "root",
      "paths": [
        {
          "id": "main-catalog",
          "name": {
            "default": "Main Catalog"
          }
        },
        {
          "id": "root",
          "name": {
            "default": "root category"
          }
        },
        {
          "id": "sub-category-2",
          "name": {
            "default": "Sub-category 2"
          }
        }
      ],
      "position": 2,
      "thumbnail": "https://example.com/on/demandware.static/-/Sites-main-catalog/default/v1447965267239/category%201.1%20thumbnail"
    }
  ],
  "creation_date": "2015-11-29T18:48:37.333Z",
  "description": {
    "default": "root category for main catalog"
  },
  "id": "root",
  "image": "https://example.com/on/demandware.static/-/Sites-main-catalog/default/v1447965267239/category%201%20image",
  "link": "https://example.com/s/-/dw/data/{version}/catalogs/main-catalog/categories/root",
  "name": {
    "default": "Root Category"
  },
  "online": true,
  "paths": [
    {
      "id": "main-catalog",
      "name": {
        "default": "Main Catalog"
      }
    },
    {
      "id": "root",
      "name": {
        "default": "root"
      }
    }
  ],
  "position": 1,
  "sorting_rules": [
    {
      "creation_date": "2015-11-19T20:46:37.000Z",
      "description": "Sorts by price ascending",
      "id": "price-low-to-high",
      "product_sorting_rule_steps": [
        {
          "direction": "Ascending",
          "is_system": false,
          "position": 0,
          "text_relevance_included": false,
          "type_id": "price"
        }
      ],
      "site": "main-site"
    },
    {
      "creation_date": "2015-11-19T20:46:37.000Z",
      "description": "Sorts by price ascending",
      "id": "price-low-to-high",
      "product_sorting_rule_steps": [
        {
          "direction": "Ascending",
          "is_system": false,
          "position": 0,
          "text_relevance_included": false,
          "type_id": "price"
        }
      ],
      "site": "main-site"
    }
  ],
  "thumbnail": "https://example.com/on/demandware.static/-/Sites-main-catalog/default/v1447965267239/category%201%20thumbnail"
}
```

### category\_links

Document representing an unfiltered list of category links.

*   `count` (_integer (int32)_) The number of returned documents.
*   `data` (_array of category\_link_)
*   `expand` (_array of string_) The list of expands set for the search request. Expands are optional.
*   `next` (_string_) The URL of the next result page.
*   `previous` (_string_) The URL of the previous result page.
*   `select` (_string_) The fields that you want to select.
*   `start` (_integer (int32)_) The zero-based index of the first search hit to include in the result.  
    Minimum: 0.
*   `total` (_integer (int32)_) The total number of documents.

_Example_

```
{
  "count": 2,
  "data": [
    {
      "last_modified": "2015-11-18.75:15:24.827Z",
      "link": "https://example.com/s/-/dw/data/{version}/catalogs/MyCatalog/categories/MyCategory1/category_links/OtherCatalog/Category1/other",
      "position": 1,
      "source_catalog_id": "MyCatalog",
      "source_catalog_name": {
        "default": "My Catalog"
      },
      "source_category_id": "MyCategory1",
      "source_category_name": {
        "default": "My Awesome Category"
      },
      "target_catalog_id": "OtherCatalog",
      "target_catalog_name": {
        "default": "That Other Catalog"
      },
      "target_category_id": "Category1",
      "target_category_name": {
        "default": "Category 1"
      },
      "type": "other"
    },
    {
      "last_modified": "2015-11-19T15:15:24.000Z",
      "link": "https://example.com/s/-/dw/data/{version}/catalogs/MyCatalog/categories/MyCategory1/category_links/OtherCatalog/Category2/other",
      "position": 2,
      "source_catalog_id": "MyCatalog",
      "source_catalog_name": {
        "default": "My Catalog"
      },
      "source_category_id": "MyCategory1",
      "source_category_name": {
        "default": "My Awesome Category"
      },
      "target_catalog_id": "OtherCatalog",
      "target_catalog_name": {
        "default": "That Other Catalog"
      },
      "target_category_id": "Category2",
      "target_category_name": {
        "default": "Category 2"
      },
      "type": "other"
    }
  ],
  "select": "(**)",
  "start": 0,
  "total": 2
}
```

### category\_link

Document representing a category link

*   `last_modified` (_string (date-time)_) The date the link was last modified
*   `link` (_string_) URL that is used to get this instance
*   `position` (_number (double)_) The position in the source catalog / category for this link relative to the other links in the same category.  
    Minimum: 0.
*   `source_catalog_id` (_string_) The source catalog for the link
*   `source_catalog_name` (_object (localized)_) The name of the source catalog
    
    Additional properties: `string`.
    
*   `source_category_id` (_string_) The source category for the link
*   `source_category_name` (_object (localized)_) The name of the source category
    
    Additional properties: `string`.
    
*   `target_catalog_id` (_string_) The target category for the link
*   `target_catalog_name` (_object (localized)_) The name of the target catalog
    
    Additional properties: `string`.
    
*   `target_category_id` (_string_) The target category for the link
*   `target_category_name` (_object (localized)_) The name of the target category
    
    Additional properties: `string`.
    
*   `type` (_string_) The link type  
    Allowed values: `other`, `accessories`, `cross_selling`, `up_selling`, `spare_parts`.

_Example_

```
{
  "last_modified": "2015-11-18.75:15:24.827Z",
  "link": "https://example.com/s/-/dw/data/{version}/catalogs/MyCatalog/categories/MyCategory1/category_links/OtherCatalog/Category1/other",
  "position": 2,
  "source_catalog_id": "MyCatalog",
  "source_catalog_name": {
    "default": "My Catalog"
  },
  "source_category_id": "MyCategory1",
  "source_category_name": {
    "default": "My Awesome Category"
  },
  "target_catalog_id": "OtherCatalog",
  "target_catalog_name": {
    "default": "That Other Catalog"
  },
  "target_category_id": "Category1",
  "target_category_name": {
    "default": "Category 1"
  },
  "type": "other"
}
```

### category\_product\_assignment\_search\_request

Document representing product\_search\_request

*   `count` (_integer (int32)_) The number of returned documents  
    Minimum: 1. Maximum: 200.
*   `db_start_record_` (_integer (int32)_) The zero-based index of the record that we want to start with, used to optimize special handling  
    Minimum: 0.
*   `expand` (_array of string_)
    
    The list of expansions that can be applied:
    
    *   product\_base - String - This expand will enable retrieval of the following basic **Product** information:
        
        *   brand
            
        *   ean
            
        *   link
            
        *   long\_description
            
        *   manufacturer\_name
            
        *   manufacturer\_sku
            
        *   name
            
        *   page\_description
            
        *   page\_keywords
            
        *   page\_title
            
        *   searchable
            
        *   short\_description
            
        *   type
            
        *   unit
            
        *   upc
            
*   `query` (_query_, required) The query passed into the search
*   `select` (_string_) The field to be selected.
*   `sorts` (_array of sort_) The list of sort clauses configured for the search request. Sort clauses are optional.
*   `start` (_integer (int32)_) The zero-based index of the first search hit to include in the result.  
    Minimum: 0.

_Example_

```
{
  "expand": [
    "product_base"
  ],
  "query": {
    "text_query": {
      "fields": [
        "product_id"
      ],
      "search_phrase": "sample_product"
    }
  },
  "select": "(**)"
}
```

### category\_product\_assignment\_search\_result

Document representing a product search result.

*   `count` (_integer (int32)_) The number of returned documents
*   `data` (_array of object_)
*   `db_start_record_` (_integer (int32)_) The zero-based index of the record that we want to start with, used to optimize special handling  
    Minimum: 0.
*   `expand` (_array of string_) List of expansions to be applied to each search results. Expands are optional
*   `hits` (_array of category\_product\_assignment_) The sorted array of search hits. This array can be empty.
*   `next` (_result\_page_) The data that can be used (as parameters on the search request) to retrieve the next result page.
*   `previous` (_result\_page_) The data that can be used (as parameters on the search request) to retrieve the previous result page.
*   `query` (_query_) The query passed into the search
*   `select` (_string_) The field to be selected.
*   `sorts` (_array of sort_) The list of sort clauses configured for the search request. Sort clauses are optional.
*   `start` (_integer (int32)_) The zero-based index of the first search hit to include in the result.  
    Minimum: 0.
*   `total` (_integer (int32)_) The number of returned documents

_Example_

```
{
  "count": 2,
  "hits": [
    {
      "catalog_id": "SampleCatalog",
      "category_id": "SampleCategory",
      "link": "https://example.com/s/-/dw/data/{version}/catalogs/SampleCatalog/category_product_assignments/SampleCategory/sample_product1",
      "owning_catalog_name": {
        "default": "Apparel Main Catalog"
      },
      "position": 1,
      "product": {
        "id": "sample_product",
        "link": "https://example.com/s/-/dw/data/{version}/products/sample_product1",
        "long_description": {
          "default": "We took this classic crew neck and updated it with jewels and embroidery."
        },
        "name": {
          "default": "Long Sleeve Appliqued Crew Neck"
        },
        "online": true,
        "page_description": {
          "default": "We took this classic crew neck and updated it with jewels and embroidery."
        },
        "page_title": {
          "default": "Long Sleeve Appliqued Crew Neck"
        },
        "searchable": true,
        "short_description": {
          "default": "We took this classic crew neck and updated it with jewels and embroidery."
        },
        "type": {
          "variant": true
        },
        "upc": "701642824237"
      },
      "product_id": "sample_product1"
    },
    {
      "catalog_id": "SampleCatalog",
      "category_id": "SampleCategory",
      "link": "https://example.com/s/-/dw/data/{version}/catalogs/SampleCatalog/category_product_assignments/SampleCategory/sample_product2",
      "owning_catalog_name": {
        "default": "Apparel Main Catalog"
      },
      "position": 2,
      "product": {
        "id": "008884304023",
        "link": "https://example.com/s/-/dw/data/{version}/products/sample_product2",
        "long_description": {
          "default": "Love our easy care solid shirting? Then give our stripes a try! This subtle blue stripe is a nice option to have in your closet for workplace wear and it even has a bit of stretch for extra comfort."
        },
        "name": {
          "default": "Platinum Blue Stripes Easy Care Fitted Shirt "
        },
        "online": true,
        "page_description": {
          "default": "Love our easy care solid shirting? Then give our stripes a try! This subtle blue stripe is a nice option to have in your closet for workplace wear and it even has a bit of stretch for extra comfort."
        },
        "page_title": {
          "default": "Platinum Blue Stripes Easy Care Fitted Shirt "
        },
        "searchable": true,
        "short_description": {
          "default": "Love our easy care solid shirting? Then give our stripes a try! This subtle blue stripe is a nice option to have in your closet for workplace wear and it even has a bit of stretch for extra comfort."
        },
        "type": {
          "variant": true
        },
        "upc": "008884304023"
      },
      "product_id": "sample_product2"
    }
  ],
  "query": {
    "text_query": {
      "fields": [
        "id"
      ],
      "search_phrase": "sample_product"
    }
  },
  "select": "**",
  "start": 0,
  "total": 2
}
```

### category\_product\_assignment

Document representing a category product assignment.

*   `catalog_id` (_string_) The id of the catalog.  
    Minimum length: 1. Maximum length: 256.
*   `category_id` (_string_) The id of the category.  
    Minimum length: 1. Maximum length: 256.
*   `creation_date` (_string (date-time)_)
*   `last_modified` (_string (date-time)_)
*   `link` (_string_) The URL used to get the product category assignment.
*   `owning_catalog_name` (_object (localized)_) The name of the catalog that owns the product.
    
    Additional properties: `string`.
    
*   `position` (_number (double)_) The position of product category assignment.
*   `product` (_product_) The product that is assigned to the category.
*   `product_id` (_string_) The id of the Product.  
    Minimum length: 1. Maximum length: 256.
*   `product_name` (_object (localized)_) The name of the product.
    
    Additional properties: `string`.
    

_Example_

```
{
  "catalog_id": "SampleCatalog",
  "category_id": "SampleCategory",
  "link": "https://example.com/s/-/dw/data/{version}/catalogs/SampleCatalog/category_product_assignments/SampleCategory/sample_product1",
  "owning_catalog_name": {
    "default": "Apparel Main Catalog"
  },
  "position": 1,
  "product": {
    "id": "sample_product",
    "link": "https://example.com/s/-/dw/data/{version}/products/sample_product1",
    "long_description": {
      "default": "We took this classic crew neck and updated it with jewels and embroidery."
    },
    "name": {
      "default": "Long Sleeve Appliqued Crew Neck"
    },
    "online": true,
    "page_description": {
      "default": "We took this classic crew neck and updated it with jewels and embroidery."
    },
    "page_title": {
      "default": "Long Sleeve Appliqued Crew Neck"
    },
    "searchable": true,
    "short_description": {
      "default": "We took this classic crew neck and updated it with jewels and embroidery."
    },
    "type": {
      "variant": true
    },
    "upc": "701642824237"
  },
  "product_id": "sample_product1"
}
```

### search\_request

Document representing a search request for retrieving items within the Data API. The query is a potentially complex set of expressions. The fields that each query supports are defined within the search resource.

*   `count` (_integer (int32)_) The number of returned documents  
    Minimum: 1. Maximum: 200.
*   `db_start_record_` (_integer (int32)_) The zero-based index of the record that we want to start with, used to optimize special handling  
    Minimum: 0.
*   `expand` (_array of string_) List of expansions to be applied to each search results. Expands are optional
*   `query` (_query_, required) The query to apply
*   `select` (_string_) The field to be selected.
*   `sorts` (_array of sort_) The list of sort clauses configured for the search request. Sort clauses are optional.
*   `start` (_integer (int32)_) The zero-based index of the first search hit to include in the result.  
    Minimum: 0.

### category\_search\_result

Document representing a catalog search result.

*   `count` (_integer (int32)_) The number of returned documents
*   `data` (_array of object_)
*   `db_start_record_` (_integer (int32)_) The zero-based index of the record that we want to start with, used to optimize special handling  
    Minimum: 0.
*   `expand` (_array of string_) List of expansions to be applied to each search results. Expands are optional
*   `hits` (_array of category_) The sorted array of search hits. Can be empty.
*   `next` (_result\_page_) The data that can be used (as parameters on the search request) to retrieve the next result page.
*   `previous` (_result\_page_) The data that can be used (as parameters on the search request) to retrieve the previous result page.
*   `query` (_query_) The query passed into the search
*   `select` (_string_) The field to be selected.
*   `sorts` (_array of sort_) The list of sort clauses configured for the search request. Sort clauses are optional.
*   `start` (_integer (int32)_) The zero-based index of the first search hit to include in the result.  
    Minimum: 0.
*   `total` (_integer (int32)_) The number of returned documents

_Example_

```
{
  "count": 1,
  "data": [
    {
      "categories": [
        {
          "creation_date": "2015-11-30T18:48:37.333Z",
          "description": {
            "default": "sub-category 1 for main catalog"
          },
          "id": "sub-category-1",
          "image": "https://example.com/on/demandware.static/-/Sites-main-catalog/default/v1447965267239/category%201.1%20image",
          "link": "https://example.com/s/-/dw/data/{version}/catalogs/main-catalog/categories/sub-category-1",
          "name": {
            "default": "Sub-category 1"
          },
          "online": true,
          "parent_category_id": "root",
          "paths": [
            {
              "id": "sub-category-1",
              "name": {
                "default": "Sub-category 1"
              }
            }
          ],
          "position": 1,
          "thumbnail": "https://example.com/on/demandware.static/-/Sites-main-catalog/default/v1447965267239/category%201.1%20thumbnail"
        }
      ],
      "creation_date": "2015-11-29T18:48:37.333Z",
      "description": {
        "default": "root category for main catalog"
      },
      "id": "root",
      "image": "https://example.com/on/demandware.static/-/Sites-main-catalog/default/v1447965267239/category%201%20image",
      "link": "https://example.com/s/-/dw/data/{version}/catalogs/main-catalog/categories/root",
      "name": {
        "default": "Root Category"
      },
      "online": true,
      "paths": [
        {
          "id": "root",
          "name": {
            "default": "root"
          }
        }
      ],
      "position": 1,
      "sorting_rules": [
        {
          "creation_date": "2015-11-19T20:46:37.000Z",
          "description": "Sorts by price ascending",
          "id": "price-low-to-high",
          "product_sorting_rule_steps": [
            {
              "direction": "Ascending",
              "is_system": false,
              "position": 0,
              "text_relevance_included": false,
              "type_id": "price"
            }
          ],
          "site": "main-site"
        }
      ],
      "thumbnail": "https://example.com/on/demandware.static/-/Sites-main-catalog/default/v1447965267239/category%201%20thumbnail"
    }
  ],
  "select": "**",
  "start": 0,
  "total": 1
}
```

### product\_options

Document representing an unfiltered list of product options.

*   `count` (_integer (int32)_) The number of returned documents.
*   `data` (_array of product\_option_)
*   `expand` (_array of string_) The list of expands set for the search request. Expands are optional.
*   `next` (_string_) The URL of the next result page.
*   `previous` (_string_) The URL of the previous result page.
*   `select` (_string_) The fields that you want to select.
*   `start` (_integer (int32)_) The zero-based index of the first search hit to include in the result.  
    Minimum: 0.
*   `total` (_integer (int32)_) The total number of documents.

_Example_

```
{
  "count": 2,
  "data": [
    {
      "custom_name": {
        "default": "Shared Service"
      },
      "default_product_option_value": "S00",
      "description": {
        "default": "Service description"
      },
      "id": "service",
      "image": {
        "abs_url": "https://example.com/on/demandware.static/-/Sites-my-catalog/default/vc8f08a6edba0d7c8e1dec6c535661e44154b54b4/Desert.jpg",
        "dis_base_url": "https://example.com/dw/image/v2/zzzz_s01/on/demandware.static/-/Sites-my-catalog/default/vc8f08a6edba0d7c8e1dec6c535661e44154b54b4/Desert.jpg",
        "path": "Desert.jpg"
      },
      "link": "https://example.com/s/-/dw/data/{version}/catalogs/my-catalog/shared_product_options/service",
      "name": "Shared Service",
      "shared": true,
      "sorting_mode": "byexplicitorder",
      "values": [
        {
          "id": "S00",
          "link": "https://example.com/s/-/dw/data/{version}/catalogs/my-catalog/shared_product_options/service/Values/S00",
          "sku_extension": "S00",
          "value": {
            "default": "None"
          }
        },
        {
          "id": "S01",
          "link": "https://example.com/s/-/dw/data/{version}/catalogs/my-catalog/shared_product_options/service/Values/S01",
          "option_price": {
            "USD": "9.99"
          },
          "sku_extension": "S01",
          "value": {
            "default": "1-year"
          }
        },
        {
          "id": "S02",
          "link": "https://example.com/s/-/dw/data/{version}/catalogs/my-catalog/shared_product_options/service/Values/S02",
          "option_price": {
            "USD": "19.99"
          },
          "sku_extension": "S02",
          "value": {
            "default": "2-year"
          }
        }
      ]
    },
    {
      "custom_name": {
        "default": "Extended Warranty"
      },
      "default_product_option_value": "000",
      "id": "warranty",
      "link": "https://example.com/s/-/dw/data/{version}/catalogs/my-catalog/shared_product_options/warranty",
      "name": "Extended Warranty",
      "shared": true,
      "sorting_mode": "byoptionprice",
      "values": [
        {
          "id": "001",
          "link": "https://example.com/s/-/dw/data/{version}/catalogs/my-catalog/shared_product_options/warranty/Values/001",
          "option_price": {
            "USD": "9.99"
          },
          "value": {
            "default": "1 Year Warranty"
          }
        },
        {
          "id": "003",
          "link": "https://example.com/s/-/dw/data/{version}/catalogs/my-catalog/shared_product_options/warranty/Values/003",
          "option_price": {
            "USD": "29.99"
          },
          "value": {
            "default": "5 Year Warranty"
          }
        },
        {
          "id": "000",
          "link": "https://example.com/s/-/dw/data/{version}/catalogs/my-catalog/shared_product_options/warranty/Values/000",
          "option_price": {
            "USD": "39.99"
          },
          "value": {
            "default": "None"
          }
        },
        {
          "id": "002",
          "link": "https://example.com/s/-/dw/data/{version}/catalogs/my-catalog/shared_product_options/warranty/Values/002",
          "option_price": {
            "USD": "49.99"
          },
          "value": {
            "default": "3 Year Warranty"
          }
        }
      ]
    }
  ],
  "select": "(**)",
  "start": 0,
  "total": 2
}
```

### product\_option

Document representing a product option

*   `custom_name` (_object (localized)_) The localized custom name of the product option.
    
    Additional properties: `string`.
    
*   `default_product_option_value` (_string_) The default product option value.
*   `description` (_object (localized)_) The localized description of the product option.
    
    Additional properties: `string`.
    
*   `id` (_string_) The object attribute definition id which is also the identifier for the product option.  
    Minimum length: 1.
*   `image` (_media\_file_) The image assigned to the product option.
*   `link` (_string_) The URL link to the product option.
*   `name` (_string_) The name of the object attribute definition.
*   `selected_option_value` (_string_) The selected option value of the product option.
*   `shared` (_boolean_) The flag that indicates if the product option is shared or local.
*   `sorting_mode` (_string_) The sorting mode for the product option values.  
    Allowed values: `byexplicitorder`, `byoptionprice`.
*   `values` (_array of product\_option\_value_) The sorted array of values of the product option.

_Example_

```
{
  "custom_name": {
    "default": "Option 15"
  },
  "description": {
    "default": "Description for Option 15"
  },
  "id": "option15",
  "image": {
    "abs_url": "https://example.com/on/demandware.static/-/Sites-my-catalog/default/vc8f08a6edba0d7c8e1dec6c535661e44154b54b4/Desert.jpg",
    "dis_base_url": "https://example.com/dw/image/v2/zzzz_s01/on/demandware.static/-/Sites-my-catalog/default/vc8f08a6edba0d7c8e1dec6c535661e44154b54b4/Desert.jpg",
    "path": "Desert.jpg"
  },
  "link": "https://example.com/s/-/dw/data/{version}/catalogs/my-catalog/shared_product_options/option15",
  "name": "15",
  "shared": true,
  "sorting_mode": "byoptionprice",
  "values": [
    {
      "id": "10",
      "link": "https://example.com/s/-/dw/data/{version}/catalogs/my-catalog/shared_product_options/option15/Values/10",
      "option_price": {
        "USD": "9.99"
      },
      "sku_extension": "12",
      "value": {
        "default": "12"
      }
    },
    {
      "id": "121",
      "link": "https://example.com/s/-/dw/data/{version}/catalogs/my-catalog/shared_product_options/option15/Values/121",
      "option_price": {
        "USD": "19.99"
      },
      "sku_extension": "12",
      "value": {
        "default": "12"
      }
    }
  ]
}
```

### product\_option\_values

Document representing an unfiltered list of product option values.

*   `count` (_integer (int32)_) The number of returned documents.
*   `data` (_array of product\_option\_value_)
*   `expand` (_array of string_) The list of expands set for the search request. Expands are optional.
*   `next` (_string_) The URL of the next result page.
*   `previous` (_string_) The URL of the previous result page.
*   `select` (_string_) The fields that you want to select.
*   `start` (_integer (int32)_) The zero-based index of the first search hit to include in the result.  
    Minimum: 0.
*   `total` (_integer (int32)_) The total number of documents.

_Example_

```
{
  "count": 3,
  "data": [
    {
      "default_product_option_value": true,
      "id": "value1",
      "link": "https://example.com/s/-/dw/data/{version}/catalogs/my-catalog/shared_product_options/my-option/values/S00",
      "sku_extension": "S00",
      "value": {
        "default": "None",
        "en": "None (en)"
      }
    },
    {
      "default_product_option_value": false,
      "id": "value2",
      "link": "https://example.com/s/-/dw/data/{version}/catalogs/my-catalog/shared_product_options/my-option/values/S01",
      "option_prices": [
        {
          "currency_mnemonic": "USD",
          "value": 9.99
        }
      ],
      "sku_extension": "S01",
      "value": {
        "default": "1-year",
        "en": "1-year (en)"
      }
    },
    {
      "default_product_option_value": false,
      "id": "value3",
      "link": "https://example.com/s/-/dw/data/{version}/catalogs/my-catalog/shared_product_options/my-option/values/S02",
      "option_prices": [
        {
          "currency_mnemonic": "USD",
          "value": 19.99
        }
      ],
      "sku_extension": "S02",
      "value": {
        "default": "2-year",
        "en": "2-year (en)"
      }
    }
  ],
  "select": "(**)",
  "start": 0,
  "total": 3
}
```

### product\_option\_value

Document representing a product option Value

*   `default_product_option_value` (_boolean_) Flag indicating if the product option value is the default value for the product option.
*   `id` (_string_) The id of the product option value.  
    Minimum length: 1.
*   `link` (_string_) The URL link to the product option value.
*   `option_prices` (_array of money_) The list of prices in the product option value.
*   `sku_extension` (_string_) The sku extension of the product option value.
*   `value` (_object (localized)_) The localized value of the product option.
    
    Additional properties: `string`.
    

_Example_

```
{
  "default_product_option_value": false,
  "id": "value3",
  "link": "https://example.com/s/-/dw/data/{version}/catalogs/my-catalog/shared_product_options/my-option/values/S02",
  "option_prices": [
    {
      "currency_mnemonic": "USD",
      "value": 19.99
    }
  ],
  "sku_extension": "S02",
  "value": {
    "default": "2-year",
    "en": "2-year (en)"
  }
}
```

### variation\_attributes

Document representing an unfiltered list of variation attributes.

*   `count` (_integer (int32)_) The number of returned documents.
*   `data` (_array of variation\_attribute_)
*   `expand` (_array of string_) The list of expands set for the search request. Expands are optional.
*   `next` (_string_) The URL of the next result page.
*   `previous` (_string_) The URL of the previous result page.
*   `select` (_string_) The fields that you want to select.
*   `start` (_integer (int32)_) The zero-based index of the first search hit to include in the result.  
    Minimum: 0.
*   `total` (_integer (int32)_) The total number of documents.

_Example_

```
{
  "count": 3,
  "data": [
    {
      "id": "fabric",
      "name": {
        "default": "Fabric"
      },
[...]
